package cdac.medinfo.sdk.hl7282.hl7model.messages.query;

import cdac.medinfo.sdk.hl7282.baselibs.messages.AbstractQuery;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DSC;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ERR;
import cdac.medinfo.sdk.hl7282.baselibs.segments.MSA;
import cdac.medinfo.sdk.hl7282.baselibs.segments.QAK;
import cdac.medinfo.sdk.hl7282.baselibs.segments.QPD;
import cdac.medinfo.sdk.hl7282.baselibs.segments.RCP;
import cdac.medinfo.sdk.hl7282.baselibs.segments.SFT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UAC;
import cdac.medinfo.sdk.hl7282.commoninterface.ISegment;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageCode;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageStructure;
import cdac.medinfo.sdk.hl7282.utils.EnumSegments;
import cdac.medinfo.sdk.hl7282.utils.EnumTriggerEvent;
import cdac.medinfo.sdk.hl7282.utils.IMap;

/**
 * RSP_K11 - Segment Pattern Response (Event K11).
 * This message is use to find the identity of the patient for specified medical record number(s).
 * <p>Represents a RSP_K11 message structure (see chapter 5.4.1). This structure contains the 
 * following elements: </p>
 * 0: MSH (Message Header) <b>SINGLE_COMPULSARY</b><br>
 * 1: SFT (Software Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 2: UAC (User Authentication Credential segment) <b>SINGLE_OPTIONAL</b><br> 
 * 3: QPD (Query Parameter Definition) <b>SINGLE_COMPULSARY</b><br>
 * 4: RCP (Response Control Parameter) <b>SINGLE_COMPULSARY</b><br>
 * 5: DSC (Continuation Pointer) <b>SINGLE_OPTIONAL</b><br>
 * This class provides mechanism to validate message against HL7 v 2.8.2 standard.
 * The class provides accessors & mutators for the elements mentioned above.
 * These elements can be easily populated & populated values can be easily retrieved.
 * The class has validate method which validates Message against HL7 v 2.8.2 standard.
 *
 * <p>Following is the step to create message<br>
 * Before that, respective Message Source and Message Recipient to be set on Message Factory.</p>
 * <p>RSP_K11 objK11 = (RSP_K11)MessageFactory.createInstance().createSendSupportedMessage("RSP", "K11");</p>
 */
public class RSP_K11 extends AbstractQuery
{
	/**
	 * Constructs the RSP_K11 message.
	 */
	RSP_K11(IMap objMessageMap)
	{
		super(objMessageMap, EnumMessageCode.RSP.getValue(), EnumTriggerEvent.K11.getValue(), EnumMessageStructure.RSP_K11.getValue());
	}
	
	/**
	 * Veifies whether message is Response.
	 * @return boolean
	 */
	public boolean isResponse()
	{
		return true;
	}	
	
	/**
	 * Retrieves the Collection of Software Segments(SFT) present in this message.
	 * @return ISingleCollection<SFT> - Collection of Software Segments(SFT) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<SFT> getSoftwareSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_SFT);
		return (ISingleCollection<SFT>)objSegmentCollection;
	}

	/**
	 * Adds the Software Segment(SFT) to this message.
	 * @param objSFT Specified Software Segment(SFT) to be added in this messageto this message.
	 */
	public void addSoftwareSegment(SFT objSFT)
	{
		addSegment(EnumSegments.HL7_SEG_SFT, objSFT);
	}

	/**
	 * Adds the collection of Software Segment(SFT) to this message.
	 * @param objSFTSegmentCollection Collection of Software Segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addSoftwareSegment(ISingleCollection<SFT>  objSFTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objSFTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_SFT, (ISingleCollection<ISegment>)objSegmentCollection);
	}
	
	/**
	 * Retrieves User Authentication Credential(UAC) segment present in this message
	 * @return UAC - the User Authentication Credential Segment present in this message or null if unavailable. 
	 */
	public UAC getUserAuthenticationCredentialSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UAC);
		if(objSingleCollection != null)
			return (UAC)objSingleCollection.elementAt(0);
		return null;
	}
	
	/**
	 * Sets value of User Authentication Credential(UAC) segment  for this message, overwrites if already present.
	 * @param objUAC Specified UAC Segment
	 */
	public void setUserAuthenticationCredentialSegment(UAC objUAC)
	{
		setSegment(EnumSegments.HL7_SEG_UAC,objUAC);
	}
	

	/**
	 * Retrieves Message Acknowledgment(MSA) segment present in this message
	 * @return MSA - the Message Acknowledgment Segment present in this message or null if unavailable.
	 */
	public MSA getMessageAcknowledgmentSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_MSA);
		if(objSingleCollection != null)
			return (MSA)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Message Acknowledgment segment for this message,overwrites if already present.
	 * @param objMSA Specified Message Acknowledgment Segment 
	 */
	public void setMessageAcknowledgmentSegment(MSA objMSA)
	{
		setSegment(EnumSegments.HL7_SEG_MSA,objMSA);
	}

	/**
	 * Retrieves Error (ERR) segment present in this message
	 * @return ERR - the Error Segment present in this message or null if unavailable.
	 */
	public ERR getErrorSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_ERR);
		if(objSingleCollection != null)
			return (ERR)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of ERR segment for this message,overwrites if already present.
	 * @param objERR Specified Error Segment 
	 */
	public void setErrorSegment(ERR objERR)
	{
		setSegment(EnumSegments.HL7_SEG_ERR,objERR);
	}

	/**
	 * Retrieves Query Acknowledgement(QAK) segment present in this message
	 * @return QAK - the Query Acknowledgement Segment present in this message or null if unavailable.
	 */
	public QAK getQueryAcknowledgementSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_QAK);
		if(objSingleCollection != null)
			return (QAK)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Query Acknowledgement segment for this message,overwrites if already present.
	 * @param objQAK Specified Query Acknowledgement Segment 
	 */
	public void setQueryAcknowledgementSegment(QAK objQAK)
	{
		setSegment(EnumSegments.HL7_SEG_QAK,objQAK);
	}
	
	/**
	 * Retrieves the Query Parameter Definition(QPD) Segment present in this message
	 * @return QPD - the Query Parameter Definition Segment present in this message or null if unavailable.
	 */
	public QPD getQueryParameterDefinitionSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_QPD);
		if(objSingleCollection != null)
			return (QPD)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Set the value of Query Parameter Definition Segment for this message,overwrites if already present.
	 * @param objQPD Specified Query Parameter Definition Segment 
	 */
	public void setQueryParameterDefinitionSegment(QPD objQPD)
	{
		setSegment(EnumSegments.HL7_SEG_QPD,objQPD);
	}
	


	/**
	 * Retrieves the Continuation Pointer(DSC) Segment present in this message
	 * @return DSC - the Continuation Pointer Segment present in this message or null if unavailable.
	 */
	public DSC getContinuationPointerSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_DSC);
		if(objSingleCollection != null)
			return (DSC)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Set the value of Continuation Pointer Segment for this message,overwrites if already present.
	 * @param objDSC Specified Continuation Pointer Segment 
	 */
	public void setContinuationPointerSegment(DSC objDSC)
	{
		setSegment(EnumSegments.HL7_SEG_DSC,objDSC);
	}

}
